Loading...
Searching...
No Matches
filter.h
/*
* Software License Agreement (BSD License)
*
* Point Cloud Library (PCL) - www.pointclouds.org
* Copyright (c) 2010-2011, Willow Garage, Inc.
*
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* * Redistributions of source code must retain the above copyright
* notice, this list of conditions and the following disclaimer.
* * Redistributions in binary form must reproduce the above
* copyright notice, this list of conditions and the following
* disclaimer in the documentation and/or other materials provided
* with the distribution.
* * Neither the name of the copyright holder(s) nor the names of its
* contributors may be used to endorse or promote products derived
* from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
* FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
* COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
* ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*
* $Id$
*
*/
#pragma once
#include <pcl/pcl_base.h>
#include <pcl/common/io.h> // for copyPointCloud
#include <pcl/PointIndices.h>
namespace pcl
{
/** \brief Removes points with x, y, or z equal to NaN
* \param[in] cloud_in the input point cloud
* \param[out] cloud_out the output point cloud
* \param[out] index the mapping (ordered): cloud_out[i] = cloud_in[index[i]]
* \note The density of the point cloud is lost.
* \note Can be called with cloud_in == cloud_out
* \ingroup filters
*/
template<typename PointT> void
removeNaNFromPointCloud (const pcl::PointCloud<PointT> &cloud_in,
pcl::PointCloud<PointT> &cloud_out,
Indices &index);
/** \brief Removes points that have their normals invalid (i.e., equal to NaN)
* \param[in] cloud_in the input point cloud
* \param[out] cloud_out the output point cloud
* \param[out] index the mapping (ordered): cloud_out[i] = cloud_in[index[i]]
* \note The density of the point cloud is lost.
* \note Can be called with cloud_in == cloud_out
* \ingroup filters
*/
template<typename PointT> void
removeNaNNormalsFromPointCloud (const pcl::PointCloud<PointT> &cloud_in,
pcl::PointCloud<PointT> &cloud_out,
Indices &index);
////////////////////////////////////////////////////////////////////////////////////////////
/** \brief Filter represents the base filter class. All filters must inherit from this interface.
* \author Radu B. Rusu
* \ingroup filters
*/
template<typename PointT>
class Filter : public PCLBase<PointT>
{
public:
using Ptr = shared_ptr<Filter<PointT> >;
using ConstPtr = shared_ptr<const Filter<PointT> >;
using PointCloud = pcl::PointCloud<PointT>;
using PointCloudPtr = typename PointCloud::Ptr;
using PointCloudConstPtr = typename PointCloud::ConstPtr;
/** \brief Empty constructor.
* \param[in] extract_removed_indices set to true if the filtered data indices should be saved in a
* separate list. Default: false.
*/
Filter (bool extract_removed_indices = false) :
removed_indices_ (new Indices),
extract_removed_indices_ (extract_removed_indices)
{
}
/** \brief Get the point indices being removed */
inline IndicesConstPtr const
getRemovedIndices () const
{
return (removed_indices_);
}
/** \brief Get the point indices being removed
* \param[out] pi the resultant point indices that have been removed
*/
inline void
getRemovedIndices (PointIndices &pi)
{
pi.indices = *removed_indices_;
}
/** \brief Calls the filtering method and returns the filtered dataset in output.
* \param[out] output the resultant filtered point cloud dataset
*/
inline void
filter (PointCloud &output)
{
if (!initCompute ())
return;
if (input_.get () == &output) // cloud_in = cloud_out
{
PointCloud output_temp;
applyFilter (output_temp);
output_temp.header = input_->header;
output_temp.sensor_origin_ = input_->sensor_origin_;
output_temp.sensor_orientation_ = input_->sensor_orientation_;
pcl::copyPointCloud (output_temp, output);
}
else
{
output.header = input_->header;
output.sensor_origin_ = input_->sensor_origin_;
output.sensor_orientation_ = input_->sensor_orientation_;
applyFilter (output);
}
deinitCompute ();
}
protected:
using PCLBase<PointT>::indices_;
using PCLBase<PointT>::input_;
using PCLBase<PointT>::initCompute;
using PCLBase<PointT>::deinitCompute;
/** \brief Indices of the points that are removed */
IndicesPtr removed_indices_;
/** \brief The filter name. */
std::string filter_name_;
/** \brief Set to true if we want to return the indices of the removed points. */
bool extract_removed_indices_;
/** \brief Abstract filter method.
*
* The implementation needs to set output.{points, width, height, is_dense}.
*
* \param[out] output the resultant filtered point cloud
*/
virtual void
applyFilter (PointCloud &output) = 0;
/** \brief Get a string representation of the name of this class. */
inline const std::string&
getClassName () const
{
return (filter_name_);
}
};
////////////////////////////////////////////////////////////////////////////////////////////
/** \brief Filter represents the base filter class. All filters must inherit from this interface.
* \author Radu B. Rusu
* \ingroup filters
*/
template<>
class PCL_EXPORTS Filter<pcl::PCLPointCloud2> : public PCLBase<pcl::PCLPointCloud2>
{
public:
using Ptr = shared_ptr<Filter<pcl::PCLPointCloud2> >;
using ConstPtr = shared_ptr<const Filter<pcl::PCLPointCloud2> >;
using PCLPointCloud2 = pcl::PCLPointCloud2;
using PCLPointCloud2Ptr = PCLPointCloud2::Ptr;
using PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr;
/** \brief Empty constructor.
* \param[in] extract_removed_indices set to true if the filtered data indices should be saved in a
* separate list. Default: false.
*/
Filter (bool extract_removed_indices = false) :
removed_indices_ (new Indices),
extract_removed_indices_ (extract_removed_indices)
{
}
/** \brief Get the point indices being removed */
inline IndicesConstPtr const
getRemovedIndices () const
{
return (removed_indices_);
}
/** \brief Get the point indices being removed
* \param[out] pi the resultant point indices that have been removed
*/
inline void
getRemovedIndices (PointIndices &pi)
{
pi.indices = *removed_indices_;
}
/** \brief Calls the filtering method and returns the filtered dataset in output.
* \param[out] output the resultant filtered point cloud dataset
*/
void
filter (PCLPointCloud2 &output);
protected:
/** \brief Indices of the points that are removed */
IndicesPtr removed_indices_;
/** \brief Set to true if we want to return the indices of the removed points. */
bool extract_removed_indices_;
/** \brief The filter name. */
std::string filter_name_;
/** \brief Abstract filter method.
*
* The implementation needs to set output.{data, row_step, point_step, width, height, is_dense}.
*
* \param[out] output the resultant filtered point cloud
*/
virtual void
applyFilter (PCLPointCloud2 &output) = 0;
/** \brief Get a string representation of the name of this class. */
inline const std::string&
getClassName () const
{
return (filter_name_);
}
};
}
#ifdef PCL_NO_PRECOMPILE
#include <pcl/filters/impl/filter.hpp>
#endif
pcl::Filter< pcl::PCLPointCloud2 >::PCLPointCloud2ConstPtr
PCLPointCloud2::ConstPtr PCLPointCloud2ConstPtr
Definition filter.h:194
pcl::Filter< pcl::PCLPointCloud2 >::PCLPointCloud2Ptr
PCLPointCloud2::Ptr PCLPointCloud2Ptr
Definition filter.h:193
pcl::Filter< pcl::PCLPointCloud2 >::applyFilter
virtual void applyFilter(PCLPointCloud2 &output)=0
Abstract filter method.
pcl::Filter< pcl::PCLPointCloud2 >::getClassName
const std::string & getClassName() const
Get a string representation of the name of this class.
Definition filter.h:250
pcl::Filter< pcl::PCLPointCloud2 >::Filter
Filter(bool extract_removed_indices=false)
Empty constructor.
Definition filter.h:200
pcl::Filter< pcl::PCLPointCloud2 >::ConstPtr
shared_ptr< const Filter< pcl::PCLPointCloud2 > > ConstPtr
Definition filter.h:190
pcl::Filter< pcl::PCLPointCloud2 >::filter_name_
std::string filter_name_
The filter name.
Definition filter.h:237
pcl::Filter< pcl::PCLPointCloud2 >::filter
void filter(PCLPointCloud2 &output)
Calls the filtering method and returns the filtered dataset in output.
pcl::Filter< pcl::PCLPointCloud2 >::removed_indices_
IndicesPtr removed_indices_
Indices of the points that are removed.
Definition filter.h:231
pcl::Filter< pcl::PCLPointCloud2 >::Ptr
shared_ptr< Filter< pcl::PCLPointCloud2 > > Ptr
Definition filter.h:189
pcl::Filter< pcl::PCLPointCloud2 >::extract_removed_indices_
bool extract_removed_indices_
Set to true if we want to return the indices of the removed points.
Definition filter.h:234
pcl::Filter< pcl::PCLPointCloud2 >::getRemovedIndices
void getRemovedIndices(PointIndices &pi)
Get the point indices being removed.
Definition filter.h:217
pcl::Filter< pcl::PCLPointCloud2 >::getRemovedIndices
IndicesConstPtr const getRemovedIndices() const
Get the point indices being removed.
Definition filter.h:208
pcl::Filter
Filter represents the base filter class.
Definition filter.h:81
pcl::Filter::filter
void filter(PointCloud &output)
Calls the filtering method and returns the filtered dataset in output.
Definition filter.h:121
pcl::Filter::applyFilter
virtual void applyFilter(PointCloud &output)=0
Abstract filter method.
pcl::Filter::PointCloudPtr
typename PointCloud::Ptr PointCloudPtr
Definition filter.h:88
pcl::Filter::PointCloudConstPtr
typename PointCloud::ConstPtr PointCloudConstPtr
Definition filter.h:89
pcl::Filter::extract_removed_indices_
bool extract_removed_indices_
Set to true if we want to return the indices of the removed points.
Definition filter.h:161
pcl::Filter::getRemovedIndices
IndicesConstPtr const getRemovedIndices() const
Get the point indices being removed.
Definition filter.h:103
pcl::Filter::Ptr
shared_ptr< Filter< PointT > > Ptr
Definition filter.h:83
pcl::Filter::ConstPtr
shared_ptr< const Filter< PointT > > ConstPtr
Definition filter.h:84
pcl::Filter::getClassName
const std::string & getClassName() const
Get a string representation of the name of this class.
Definition filter.h:174
pcl::Filter::filter_name_
std::string filter_name_
The filter name.
Definition filter.h:158
pcl::Filter::getRemovedIndices
void getRemovedIndices(PointIndices &pi)
Get the point indices being removed.
Definition filter.h:112
pcl::Filter::removed_indices_
IndicesPtr removed_indices_
Indices of the points that are removed.
Definition filter.h:155
pcl::Filter::Filter
Filter(bool extract_removed_indices=false)
Empty constructor.
Definition filter.h:95
pcl::PCLBase
PCL base class.
Definition pcl_base.h:70
pcl::PCLBase::input_
PointCloudConstPtr input_
The input point cloud dataset.
Definition pcl_base.h:147
pcl::PCLBase::indices_
IndicesPtr indices_
A pointer to the vector of point indices to use.
Definition pcl_base.h:150
pcl::PCLBase::initCompute
bool initCompute()
This method should get called before starting the actual computation.
Definition pcl_base.hpp:138
pcl::PCLBase::deinitCompute
bool deinitCompute()
This method should get called after finishing the actual computation.
Definition pcl_base.hpp:175
pcl::PointCloud
PointCloud represents the base class in PCL for storing collections of 3D points.
Definition point_cloud.h:173
pcl::PointCloud::sensor_orientation_
Eigen::Quaternionf sensor_orientation_
Sensor acquisition pose (rotation).
Definition point_cloud.h:408
pcl::PointCloud::header
pcl::PCLHeader header
The point cloud header.
Definition point_cloud.h:392
pcl::PointCloud::sensor_origin_
Eigen::Vector4f sensor_origin_
Sensor acquisition pose (origin/translation).
Definition point_cloud.h:406
pcl::PointCloud::Ptr
shared_ptr< PointCloud< PointT > > Ptr
Definition point_cloud.h:413
pcl::PointCloud::ConstPtr
shared_ptr< const PointCloud< PointT > > ConstPtr
Definition point_cloud.h:414
pcl::copyPointCloud
void copyPointCloud(const pcl::PointCloud< PointInT > &cloud_in, pcl::PointCloud< PointOutT > &cloud_out)
Copy all the fields from a given point cloud into a new point cloud.
Definition io.hpp:142
pcl::removeNaNNormalsFromPointCloud
void removeNaNNormalsFromPointCloud(const pcl::PointCloud< PointT > &cloud_in, pcl::PointCloud< PointT > &cloud_out, Indices &index)
Removes points that have their normals invalid (i.e., equal to NaN)
Definition filter.hpp:99
pcl::removeNaNFromPointCloud
void removeNaNFromPointCloud(const pcl::PointCloud< PointT > &cloud_in, pcl::PointCloud< PointT > &cloud_out, Indices &index)
Removes points with x, y, or z equal to NaN.
Definition filter.hpp:46
pcl
Definition convolution.h:46
pcl::IndicesConstPtr
shared_ptr< const Indices > IndicesConstPtr
Definition pcl_base.h:59
pcl::Indices
IndicesAllocator<> Indices
Type used for indices in PCL.
Definition types.h:133
pcl::IndicesPtr
shared_ptr< Indices > IndicesPtr
Definition pcl_base.h:58
pcl::PCLPointCloud2
Definition PCLPointCloud2.h:17
pcl::PCLPointCloud2::Ptr
shared_ptr< ::pcl::PCLPointCloud2 > Ptr
Definition PCLPointCloud2.h:35
pcl::PCLPointCloud2::ConstPtr
shared_ptr< const ::pcl::PCLPointCloud2 > ConstPtr
Definition PCLPointCloud2.h:36
pcl::PointIndices
Definition PointIndices.h:12
pcl::PointIndices::indices
Indices indices
Definition PointIndices.h:20
pcl::PointXYZRGB
A point structure representing Euclidean xyz coordinates, and the RGB color.
Definition point_types.hpp:594